package ch.sahits.sort;

import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import java.util.Arrays;
import java.util.Random;

import org.junit.Before;
import org.junit.Test;


public class QuicksortTest {

	private int[] numbers;
	int SIZE = 0xffffff;
	long time1=0;
	long time2=0;
	long time3=0;
	private final static int MAX = 20;
	boolean sopOff=false;

	@Before
	public void setUp() throws Exception {
		numbers = new int[SIZE];
		Random generator = new Random();
		for (int i = 0; i < numbers.length; i++) {
			numbers[i] = generator.nextInt(MAX);
		}
	}

	@Test
	public void testQuickSort() {
		ISort sorter = new Quicksort();
		testSorting(sorter);
	}
	@Test
	public void testQuickSortThreadded() {
		ISort sorter = new QuicksortThreadded();
		testSorting(sorter);
	}

	private void testSorting(ISort sorter) {
//		for (Integer i : numbers) {
//			System.out.println(i + " ");
//		}
		long startTime = System.nanoTime();

		sorter.sort(numbers);

		long stopTime = System.nanoTime();
		if (sorter.getClass()==Quicksort.class){
			time1 = stopTime - startTime;
			if (!sopOff)
				System.out.println("Quicksort ("+sorter.getClass().getName()+") " + time1);
		} else { 
			time2 = stopTime - startTime;
			if (!sopOff)
				System.out.println("Quicksort ("+sorter.getClass().getName()+") " + time2);
		}

		for (int i = 0; i < numbers.length - 1; i++) {
			if (numbers[i] > numbers[i + 1]) {
				fail("Should not happen");
			}
		}
		assertTrue(true);
	}
	

	@Test
	public void testStandardSort() {
		long startTime = System.nanoTime();
		Arrays.sort(numbers);
		long stopTime = System.nanoTime();
		time3 = stopTime - startTime;
		if (!sopOff)
			System.out.println("Standard Java sort " + time3);

		for (int i = 0; i < numbers.length - 1; i++) {
			if (numbers[i] > numbers[i + 1]) {
				fail("Should not happen");
			}
		}
		assertTrue(true);
	}

}
