package ch.sahits.sort;

public class QuicksortThreadded extends Thread implements ISort{
	private int[] numbers;
	private int number;
	private static int nrOfSpawns = 1; // this
	private static int nrOfProcessors;
	static {
		Runtime runtime = Runtime.getRuntime();        
		nrOfProcessors = runtime.availableProcessors();
	}
	private int lower;
	private int upper;
	QuicksortThreadded(){
		
	}
	QuicksortThreadded(int _lower, int _upper, int[] array){
		lower=_lower;
		upper=_upper;
		numbers=array;
	}
	

	/* (non-Javadoc)
	 * @see ch.sahits.sort.ISort#sort(int[])
	 */
	public void sort(int[] values) {
		this.numbers = values;
		number = values.length;
		quicksort(0, number - 1);
	}
	

	@Override
	public void run() {
		quicksort(lower,upper);
	}
	private void quicksort(int low, int high) { // pass the array to be sorted
		int i = low, j = high;
		// Get the pivot element from the middle of the list
		int pivot = numbers[(low + high) / 2];

		// Divide into two lists
		while (i <= j) {
			// If the current value from the left list is smaller then the pivot
			// element then get the next element from the left list
			while (numbers[i] < pivot) {
				i++;
			}
			// If the current value from the right list is larger then the pivot
			// element then get the next element from the right list
			while (numbers[j] > pivot) {
				j--;
			}

			// If we have found a values in the left list which is larger then
			// the pivot element and if we have found a value in the right list
			// which is smaller then the pivot element then we exchange the
			// values.
			// As we are done we can increase i and j
			if (i <= j) {
				exchange(i, j);
				i++;
				j--;
			}
		}
		// Recursion
		boolean maxThreadreached = (nrOfSpawns>=nrOfProcessors);
		QuicksortThreadded t = null;
		if (low < j){
			if (maxThreadreached)
				quicksort(low, j);
			else {
				t = new QuicksortThreadded(low,j,numbers);
				t.start();
				nrOfSpawns++;
			}
		}
		if (i < high){
			quicksort(i, high);
		}
		if (t!=null){
			try {
				t.join();
				nrOfSpawns--;
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

	private void exchange(int i, int j) {
		int temp = numbers[i];
		numbers[i] = numbers[j];
		numbers[j] = temp;
	}
}
